/*******************************************************************************
 *
 * OpenBlueSky - Enhanced NetBeans RCP Components
 * =====================================================
 *
 * Copyright (C) 2003-2009 by Fabrizio Giudici
 * Project home page: http://openbluesky.dev.java.net
 *
 *******************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License. 
 *
 *******************************************************************************
 *
 * $Id$
 *
 ******************************************************************************/
package it.tidalwave.swing;

import java.lang.reflect.Method;

/*******************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 ******************************************************************************/
public final class DisplayNameListCellRenderer<T> extends SimpleListCellRenderer<T>
  {
    private final Method getDisplayNameMethod;
    
    public DisplayNameListCellRenderer (final Class<T> clazz) 
      {
        try 
          {
            getDisplayNameMethod = clazz.getMethod("getDisplayName");
          } 
        catch (NoSuchMethodException e) 
          {
            throw new RuntimeException(e);
          } 
        catch (SecurityException e) 
          {
            throw new RuntimeException(e);
          }
      }

    @Override  @edu.umd.cs.findbugs.annotations.SuppressWarnings("REC_CATCH_EXCEPTION")
    protected String getDisplayName (final T object) 
      {
        try 
          {
            return (String)getDisplayNameMethod.invoke(object);
          } 
        catch (Exception e) 
          {
            return "????";
          }   
      }
  }  
